---
title: "Rust 语言技术初阶"
date: 2018-12-29
lastmod: 2020-01-05
weight: 1
type: 
icon: #
description: "Rust 语言技术初阶"
# search related keywords
---

- 基础语法
  - 常量、变量、绑定
    - let关键字
    - mut修饰符
    - const修饰符
  - 语句与表达式
    - 语句和表达式的区别
    - 行末的分号
  - 循环语句
    - loop
    - while
    - for
    - break
    - loop label
  - 条件判断语句
    - if
    - else
    - else if
  - 基本运算符
    - 算术运算符
    - 逻辑运算符
    - 位移运算符
  - 函数与闭包
    - fn关键字
    - 函数参数的写法
    - 函数的返回值 
    - 闭包
    - 闭包的参数和返回值
  - match表达式
    - match的语法和分支
    - 默认分支
- 数据类型
  - 基础数据类型
    - 数字类型
      - 有符号数类型
        - i8/i16/i32/i64/i128/isize
      - 无符号数类型
        - u8/u16/u32/u64/u128/usize
      - 浮点数类型
        - f32/f64
    - 布尔类型
      - bool
    - 字符类型
      - char
    - 数组类型
      - []
    - range类型
      - range()
    - slice类型
      - 内存切片
    - str类型
      - 静态字符串
    - String类型
      - 动态字符串
  - 复合数据类型
    - 元组()
    - 结构体struct
    - 枚举enum
    - union
  - 集合类型
    - Vector
    - HashMap
    - HashSet
- 模式匹配
  - match基本形式
  - match+enum实现分支处理
  - if let
  - while let
  - 函数参数中的模式匹配
- module组织
  - 多模块文件的组织
  - 多模块文件的引入和路径寻址
  - pub
    - 模块供外部访问的部分的导出修饰符
- cargo包管理系统 
  - cargo的基本使用
  - 外部crate的引入和使用
- 打印、调试与输入输出 
  - println!
  - debug!
  - std::io
  - io::stdin() 
  - io::stdout() 
- 文件操作
  - std::fs
  - 文件的增删改查
  - 目录的操作
- 注释
  - 行注释
  - 块注释
  - 文档型注释
  - 文档型注释中的markdown支持
  - 文档型注释中的代码测试支持