---
title: "Rust 语言技术高阶"
date: 2018-12-29
lastmod: 2020-01-05
weight: 3
type: 
icon: #
description: "Rust 语言技术高阶"
# search related keywords
---

- 原始指针
  - 原始指针
    - `*const`、`*mut`
  - 原始指针与其它引用和指针类型的转换
  - 原始指针在标准库中出现的使用函数
- unsafe Rust
  - unsafe关键字
  - safe Rust与unsafe Rust
  - unsafe Rust与C的安全性区别
  - unsafe Rust的意义
- 高级trait
  - 关联类型
  - 关联常量
  - trait中的泛型
- 高级lifetime
  - 多生命周期
  - 生命周期的依赖
- 函数式编程风格
  - 标准库中的一套方法
    - map、fold、filter、then等
  - 链式写法
  - 函数式编程中的副作用
- Rust设计模式（扩展）
  - 工厂模式
  - OOP模式
  - 状态机模式
- Rust FFI开发
  - 从C库中导入函数
  - 使用Rust为其它语言写函数库
  - Rust与C++交互开发
  - Rust与动态语言交互开发
- 安全并发
  - Send与Sync
  - 锁的使用分析
  - 无锁数据结构
  - 高性能并发编程
    - rayon、crossbeam库等
- 内存布局
  - Rust中数据结构的内存布局
  - Rust内存布局与C的区别
- 宏开发
  - 自己动手写declare macro
  - 自动动手写procedure macro
- 元编程
  - build.rs构建期编程
  - 使用过程宏实现编译期代码操作
  - 类型反射相关
    - Any、downcast
- 解析器开发
  - 解析器的重要意义
  - Rust为何适合用来写解析器
  - nom解析器快速开发
    - nom
  - 序列化库
    - serde
- 异步编程Poll模式开发
  - 深刻理解Future
    - Reactor、Waker、Executor
  - 学习Future的Poll状态机开发模式
    - Context
  - Pin
    - Pin相关知识点
  - Poll开发模式需要注意的一些点
- Rust与Wasm开发
  - WebAssembly介绍 
  - Rust为何适合用来开发wasm应用
  - 其它语言开发wasm应用的对比
  - Wasm-bindgen